! Convert Sokoban Levels to 3S format
! Copyright (C) 2003 Nils M Holm
!
! Usage: tx convert.t
!        txx convert <input-file >output-file

module convert(t3x, string, iostream);

object	t[t3x], str[string];

const	BUFLEN = 1024;
const	STRLEN = 128;

object	In[iostream], Out[iostream];
var	Inbuf::BUFLEN, Outbuf::BUFLEN;
var	Buffer::STRLEN;
var	Map;

init() do
	In.create(T3X.SYSIN, Inbuf, BUFLEN, IOSTREAM.FREAD|IOSTREAM.FKILLCR);
	Out.create(T3X.SYSOUT, Outbuf, BUFLEN, IOSTREAM.FWRITE);
	Map := [
		[ '#', 'X' ],	! Wall
		[ ' ', ' ' ],	! Floor
		[ '.', ':' ],	! Safe place
		[ '@', '@' ],	! Player
		[ '$', '#' ],	! Piece
		[ '+', '%' ],	! Player on safe place
		[ '*', '!' ],	! Piece on safe place
		0
	];
end

fini() do
	In.flush();
	Out.flush();
end

trim(s, k) do var i;
	k := k-1;
	while (k >= 0 /\ s::k = '\s' \/ s::k = '\n') k := k-1;
	k := k+1;
	s::k := 0;
	return k;
end

double(s) do var i, j, b::STRLEN;
	i := 0;
	j := 0;
	while (s::i) do
		b::j := s::i;
		b::(j+1) := s::i;
		i := i+1;
		j := j+2;
	end
	b::j := 0;
	str.copy(s, b);
end

translate(s) do var i;
	i := 0;
	while (Map[i]) do
		str.xlate(s, Map[i][0], Map[i][1]);
		i := i+1;
	end
end

convert() do var k, n, comment::STRLEN;
	Out.writes("3S-LEVELS\n");
	Out.writes("C\n");
	Out.writes("C $Place Credits here$.\n");
	Out.writes("C\n");
	n := 1;
	while (1) do
		k := In.reads(Buffer, STRLEN);
		if (In.eof() \/ k < 1) leave;
		k := trim(Buffer, k);
		if (k = 0) loop;
		if (Buffer::0 = ';') do
			k := In.reads(Buffer, STRLEN);
			if (In.eof() \/ k < 1) leave;
			k := trim(Buffer, k);
			ie (Buffer::0 = ''') do
				str.parse(Buffer, "'%:'s'", [(comment)]);
				Out.writes(str.format(Buffer, "%d %s\n",
					[(n, comment)]));
				loop;
			end
			else do
				Out.writes(str.format(comment, "%d\n", [(n)]));
			end
			n := n+1;
			if (k = 0) loop;
		end
		translate(Buffer);
		double(Buffer);
		Out.writes(Buffer);
		Out.wrch('\n');
	end
end

do
	init();
	convert();
	fini();
end
